;------------------------------------------------------------------------------------------------Initialisierung
AppTitle "US Bitmap Font Wizard"

;Bitmapfont
Global bitmapfont				;Bitmapfont Image
Global bitmapfont_frames		;Bitmapfont Frames
Global bitmapfont_framesx		;Bitmapfont Frame X Size
Global bitmapfont_framesy		;Bitmapfont Frame Y Size
Dim bitmapfont_c(0)			;Bitmapfont Char ASCII
Dim bitmapfont_w(0)			;Bitmapfont Char Width
Global mask
Global gradient

;Layers
Global layer
Dim layer_name$(9)
Dim layer_font(9)
Dim layer_rgb1(9,2)
Dim layer_rgb2(9,2)
Dim layer_gradient(9)
Dim layer_texture(9)
Dim layer_border(9)
Dim layer_x(9)
Dim layer_y(9)

;Mask
Dim mac(2)
mac(0)=255
mac(1)=0
mac(2)=255
Dim mac2(2)
mac2(0)=0
mac2(1)=0
mac2(2)=0

;Current Gradient
Global curgrad=0


;Font
Global arial=LoadFont("Arial",12)

;Main Win
Global win=CreateWindow("Unreal Software's Bitmap Font Wizard 1.1 - www.unrealsoftware.de",0,0,640,480,Desktop(),5)

;Win Menu: File
Global win_file=CreateMenu("File",0,WindowMenu(win))
Global win_new=CreateMenu("New",1,win_file)
;Global win_open=CreateMenu("Open...",2,win_file):DisableMenu win_open
;Global win_save=CreateMenu("Save...",3,win_file):DisableMenu win_save
CreateMenu("",9,win_file)
Global win_export=CreateMenu("Export as BMP...",10,win_file)
CreateMenu("",19,win_file)
Global win_quit=CreateMenu("Quit",20,win_file)
;Win Menu: Wizard
;Global win_wizard=CreateMenu("Wizard",30,WindowMenu(win)):DisableMenu win_wizard

UpdateWindowMenu(win)

;Win Canavas: Font
Global win_preview=CreateCanvas(5,110,400,285,win,65536)

;Layers
Dim win_layer(9)
i=0
For x=0 To 1
	For y=0 To 4
		win_layer(i)=CreateButton("",5+x*200,5+y*15,200,15,win,3)
		i=i+1
	Next
Next

;Preview
Global win_preview_txt=CreateTextField(5,403,300,20,win)
Global win_update=CreateButton("Preview",310,403,95,20,win)

;Options - Layer
Global opt_layer=CreateLabel("Layer 1",410,8,60,20,win)
Global opt_layer_name=CreateTextField(470,5,215-60,20,win)

;Options - Font
Global opt_font_prev=CreateLabel("",410,35,215,70,win,3)
Global opt_font_load=CreateButton("Load Font",410,110,105,20,win)
Global opt_font_delete=CreateButton("Delete Font",520,110,105,20,win)

;Options - Color
Global opt_color1=CreatePanel(410,145,105,20,win,1)
Global opt_color2=CreatePanel(520,145,105,20,win,1)

;Options - Gradient
Dim opt_gradient(5)
i=0
For x=0 To 2
	For y=0 To 1
		opt_gradient(i)=CreateCanvas(410+(x*72),170+(y*45),67,40,win)
		i=i+1
	Next
Next

;Options - Texture Fill
Global opt_texfill=CreateButton("Texture Fill",410,260,215,20,win)


;Options - Border
CreateLabel("Border:",410,300+8,60,20,win)
Global opt_border_thick=CreateTextField(470,300+5,215-60,20,win)

;Options - Offset
CreateLabel("X Offset:",410,340+8,60,20,win)
Global opt_x=CreateTextField(470,340+5,215-60,20,win)
CreateLabel("Y Offset:",410,365+8,60,20,win)
Global opt_y=CreateTextField(470,365+5,215-60,20,win)

;Options - Save
Global opt_save=CreateButton("Save Layer Settings",410,403,215,20,win)



;Export
Global win_exp=CreateWindow("Export as BMP",0,0,350,400,win,1)

;Export - Bitmap
CreateLabel("Bitmap File:",5,5,250,20,win_exp)
Global win_exp_bmp=CreateTextField(5,25,300,20,win_exp):SetGadgetText win_exp_bmp,"MyBitmapFont.bmp"
Global win_exp_bmp_browse=CreateButton("...",310,25,30,20,win_exp)

;Export - Widths
Global win_exp_w_ch=CreateButton("Export Char Widths:",5,60,250,20,win_exp,2)
Global win_exp_w=CreateTextField(5,80,300,20,win_exp):SetGadgetText win_exp_w,"MyBitmapFont.inf"
Global win_exp_w_browse=CreateButton("...",310,80,30,20,win_exp)

;Export - Bmpf-Files
Global win_exp_bmpf_ch=CreateButton("Export BMPF File:",5,115,250,20,win_exp,2)
Global win_exp_bmpf=CreateTextField(5,135,300,20,win_exp):SetGadgetText win_exp_bmpf,"MyBitmapFont.bmpf"
Global win_exp_bmpf_browse=CreateButton("...",310,135,30,20,win_exp)

;Export - Mask Color
CreateLabel("Background Color:",5,170,250,20,win_exp)
Global win_exp_background=CreatePanel(5,190,105,20,win_exp,1)
SetPanelColor win_exp_background,mac(0),mac(1),mac(2)

;Export - Char Set
CreateLabel("Char Set:",5,210,250,20,win_exp)
Global win_exp_ch_sel=CreateComboBox(5,210,335,20,win_exp)
AddGadgetItem(win_exp_ch_sel,"ASCII (256 chars)",1)
AddGadgetItem(win_exp_ch_sel,"ASCII 33-126  (94 chars)")
AddGadgetItem(win_exp_ch_sel,"Numbers (10)")
AddGadgetItem(win_exp_ch_sel,"Alphabet a (26)")
AddGadgetItem(win_exp_ch_sel,"Alphabet b (52)")
AddGadgetItem(win_exp_ch_sel,"Basic (62)")
AddGadgetItem(win_exp_ch_sel,"Custom")
Global win_exp_ch=CreateTextArea(5,235,335,70,win_exp,1)
charset()

;Export - Buttons
Global win_exp_cancel=CreateButton("Cancel",5,345,100,20,win_exp)
Global win_exp_export=CreateButton("Export",240,345,100,20,win_exp)

;Export - Additional 
Global win_exp_sharp=CreateButton("Run Sharpness-Filters",5,320,150,20,win_exp,2):SetButtonState win_exp_sharp,1
Global win_exp_info=CreateButton("Display Info/Code",155,320,250,20,win_exp,2):SetButtonState win_exp_info,1

HideGadget win_exp

;Info
Global win_inf=CreateWindow("Bitmap Font Information",0,0,350,400,win,1)

;Info - Infos
Global win_inf_frames=CreateLabel("Frames/Chars: ",5,5,250,20,win_inf)
Global win_inf_framesx=CreateLabel("Frame Width (X): ",5,25,250,20,win_inf)
Global win_inf_framesy=CreateLabel("Frame Height (Y): ",5,45,250,20,win_inf)

;Info - Chars
CreateLabel("Char Widths: ",5,70,250,20,win_inf)
Global win_inf_charw=CreateTextArea(5,90,150,60,win_inf)

;Info - Code
CreateLabel("Code (Blitz Basic): ",5,170,250,15,win_inf)
Global win_inf_code=CreateTextArea(5,190,335,150,win_inf)

;Info - OK
Global win_inf_ok=CreateButton("Ok",5,345,335,20,win_inf)

HideGadget win_inf




;Progress
Global win_progrbar=CreateProgBar(5,85,400,20,win)
HideGadget win_progrbar


clear()

;------------------------------------------------------------------------------------------------Runtime


Repeat
	
	event=WaitEvent(120)
	
	If MouseHit(1) Then
		For i=0 To 5
			If opt_gradient(i)=curgrad Then
				layer_gradient(layer)=i
				gradients()
			EndIf
		Next
	EndIf
	
	
	If event<>0 Then
		Select event
			
			;Canvas
			Case $203,205
				curgrad=EventSource()
			Case $206
				curgrad=0
				
			
			;Menu
			Case $1001
				Select EventData()
				
				
				;New
				Case 1
					If Confirm("This will delete your current font."+Chr$(13)+"Are you sure?",0) Then clear()
					
				;Export
				Case 10
					ShowGadget win_exp
					
				;Quit
				Case 20
					If Confirm("Quit Bitmap Font Wizard?",1) Then End

				End Select
			;Klick
			Case $401,$201
				Select EventSource()
					
					;------------------------Main
					
					;Update
					Case win_update
						preview()
										
					;------------------------Layer
					
					;Layer
					Case win_layer(0),win_layer(1),win_layer(2),win_layer(3),win_layer(4),win_layer(5),win_layer(6),win_layer(7),win_layer(8),win_layer(9)
						layer_load
					
					;Layer Font
					Case opt_font_load
						tempfont=RequestFont()
						If tempfont<>0 Then
							If layer_font(layer)<>0 Then FreeFont layer_font(layer)
							layer_font(layer)=tempfont
							If layer_font(layer)=0 Then
								SetGadgetText opt_font_prev,"No Font loaded!"
								SetGadgetFont opt_font_prev,arial
							Else
								SetGadgetText opt_font_prev,"AaBbYyZz"
								SetGadgetFont opt_font_prev,layer_font(layer)
							EndIf
							layer_save()
						EndIf
						
					;Delete Layer Font
					Case opt_font_delete
						If layer_font(layer)<>0 Then FreeFont layer_font(layer)
						layer_font(layer)=0
						SetGadgetText opt_font_prev,"No Font loaded!"
						SetGadgetFont opt_font_prev,arial
						layer_save()
						
					;Layer Color 1
					Case opt_color1
						RequestColor(layer_rgb1(layer,0),layer_rgb1(layer,1),layer_rgb1(layer,2))
						layer_rgb1(layer,0)=RequestedRed()
						layer_rgb1(layer,1)=RequestedGreen()
						layer_rgb1(layer,2)=RequestedBlue()
						SetPanelColor opt_color1,layer_rgb1(layer,0),layer_rgb1(layer,1),layer_rgb1(layer,2)
						gradients()
						
					;Layer Color 2
					Case opt_color2
						RequestColor(layer_rgb2(layer,0),layer_rgb2(layer,1),layer_rgb2(layer,2))
						layer_rgb2(layer,0)=RequestedRed()
						layer_rgb2(layer,1)=RequestedGreen()
						layer_rgb2(layer,2)=RequestedBlue()
						SetPanelColor opt_color2,layer_rgb2(layer,0),layer_rgb2(layer,1),layer_rgb2(layer,2)
						gradients()
						
					;Layer Texture
					Case opt_texfill
						If layer_texture(layer)<>0 Then FreeImage layer_texture(layer):layer_texture(layer)=0
						file$=RequestFile("Load Layer Texture...","",0)
						If file$<>"" Then
							layer_texture(layer)=LoadImage(file$)
							If layer_texture(layer)=0 Then
								Notify("Error: Invalid Source File!"+Chr(13)+"Supported Image Types: bmp, jpg, png, pcx, tga, iff",1)
							Else
								layer_gradient(layer)=6
								gradients()
							EndIf
						EndIf
						
											
					;Layer Save
					Case opt_save
						layer_save()
						
						
						
					;----Export
					
					;Export Bitmap
					Case win_exp_bmp_browse
						req$=RequestFile("Save Bitmap as...","bmp",1)
						If Len(req$)>4 Then
							SetGadgetText win_exp_bmp,req$
						EndIf
						
					;Export Widths
					Case win_exp_w_browse
						req$=RequestFile("Save Char Widths as...","inf,dat,cfg,txt",1)
						If Len(req$)>4 Then
							SetGadgetText win_exp_w,req$
						EndIf
						
					;Export BMPF
					Case win_exp_w_browse
						req$=RequestFile("Save BMPF File as...","bmpf",1)
						If Len(req$)>4 Then
							SetGadgetText win_exp_bmpf,req$
						EndIf
						
					;Color
					Case win_exp_background
						RequestColor(mac(0),mac(1),mac(2))
						mac(0)=RequestedRed()
						mac(1)=RequestedGreen()
						mac(2)=RequestedBlue()
						SetPanelColor win_exp_background,mac(0),mac(1),mac(2)
						
					;Charset
					Case win_exp_ch_sel
						charset
						
					;Cancel
					Case win_exp_cancel
						HideGadget win_exp
						ActivateWindow win
						
					;Export
					Case win_exp_export
						;Prepare
						ok=1
						charset$=Trim(TextAreaText(win_exp_ch))
						If Len(TextFieldText(win_exp_bmp))<1 Then
							Notify("You have to enter a path/name for the bitmap!",1):ok=0
						ElseIf Len(charset$)<1
							Notify("You have to enter a least 1 char!",1):ok=0
						EndIf
						
						;Generate & Export
						If ok=1				
							HideGadget win_exp
							ActivateWindow win
							ShowGadget win
							If ButtonState(win_exp_w_ch)=1 Then
								output_w$=TextFieldText(win_exp_w)
							Else
								output_w$=""
							EndIf
							If ButtonState(win_exp_bmpf_ch)=1 Then
								output_bmpf$=TextFieldText(win_exp_bmpf)
							Else
								output_bmpf$=""
							EndIf
							
							ok=generate(charset$,TextFieldText(win_exp_bmp),output_w$,ButtonState(win_exp_sharp),0,output_bmpf$)

							
							;Info
							If ok=1 Then
								If ButtonState(win_exp_info)=1 Then
									infos(1)
								EndIf
							EndIf
						EndIf
						
						ActivateWindow win

						
					
					;----Info
					
					;Ok
					Case win_inf_ok
						HideGadget win_inf
						ShowGadget win
						ActivateWindow win
					
					
				End Select
			
			;Quit	
			Case $803
				closedwin=EventSource()
					If closedwin=win Then
						If Confirm("Quit Bitmap Font Wizard?",1) Then End
					Else
						HideGadget closedwin
						ActivateWindow win
					EndIf
		
		
		
		End Select
	EndIf
Forever

;------------------------------------------------------------------------------------------------Functions

;Preview
Function preview()
	layer_save()
	Local prevtxt$=TextFieldText(win_preview_txt)
	;LAYERS
	;For i=9 To 0 Step -1
	;	If layer_font(i)<>0 Then
	;		SetFont layer_font(i)
	;		Color layer_rgb1(i,0), layer_rgb1(i,1), layer_rgb1(i,2)
	;		For x=-layer_border(i) To layer_border(i)
	;			For y=-layer_border(i) To layer_border(i)
	;				Text 200+x+layer_x(i),142+y+layer_y(i), prevtxt$ , 1,1
	;			Next
	;		Next
	;	EndIf
	;Next
	generate(prevtxt$,"","",1,1)
End Function

;Clear
Function clear()
	For i=0 To 9
		layer_name$(i)="Unnamed"
		If layer_font(i)<>0 Then FreeFont  layer_font(i): layer_font(i)=0
		SetGadgetText win_layer(i),"Layer "+(i)+" - "+layer_name$(i)
		SetButtonState win_layer(i),0
	Next
	Dim layer_rgb1(9,2)
	Dim layer_rgb2(9,2)
	For i=0 To 9
		For j=0 To 2
			layer_rgb2(i,j)=255
		Next
	Next
	Dim layer_gradient(9)
	For i=0 To 9
		If layer_texture(i)<>0 Then FreeImage layer_texture(i)
		layer_texture(i)=0
	Next
	Dim layer_border(9)
	Dim layer_x(9)
	Dim layer_y(9)
	SetButtonState win_layer(0),1
	SetGadgetText win_preview_txt,"Sample Text"
	layer_load()
	;Canvas
	SetBuffer CanvasBuffer(win_preview)
	Color 150,150,150
	Rect 0,0,400,285,1
	Color 200,200,200
	i=0
	For y=0 To 285 Step 8
		For x=0 To 400 Step 8
			i=1-i
			If i Then Rect x,y,8,8,1
		Next
	Next
	FlipCanvas(win_preview)
End Function

;Gradients
Function gradients()
	Local r1,g1,b1
	Local r2,g2,b2
	Local rc#,gc#,bc#
	Local ra#,ga#,ba#
	r1=layer_rgb1(layer,0)
	g1=layer_rgb1(layer,1)
	b1=layer_rgb1(layer,2)
	r2=layer_rgb2(layer,0)
	g2=layer_rgb2(layer,1)
	b2=layer_rgb2(layer,2)
	;Gradient 0
	SetBuffer CanvasBuffer(opt_gradient(0))
	ClsColor r1,g1,b1
	Cls
	If layer_gradient(layer)=0 Then Color 0,255,0:Rect 0,0,67,40,0
	FlipCanvas(opt_gradient(0))
	;Gradient 1
	SetBuffer CanvasBuffer(opt_gradient(1))
	ClsColor r2,g2,b2
	Cls
	rc=r2:gc=g2:bc=b2
	ra=r2-r1:ga=g2-g1:ba=b2-b1
	If ra<>0 Then ra=ra/34.
	If ga<>0 Then ga=ga/34.
	If ba<>0 Then ba=ba/34.
	For i=34 To 0 Step -1
		rc=rc-ra:gc=gc-ga:bc=bc-ba
		Color rc,gc,bc
		Oval 34-i,20-i,(i*2),(i*2),1
	Next
	If layer_gradient(layer)=1 Then Color 0,255,0:Rect 0,0,67,40,0
	FlipCanvas(opt_gradient(1))
	;Gradient 2
	SetBuffer CanvasBuffer(opt_gradient(2))
	ClsColor r1,g1,b1
	Cls
	rc=r1:gc=g1:bc=b1
	ra=r1-r2:ga=g1-g2:ba=b1-b2
	If ra<>0 Then ra=ra/67.
	If ga<>0 Then ga=ga/67.
	If ba<>0 Then ba=ba/67.
	For x=0 To 67
		rc=rc-ra:gc=gc-ga:bc=bc-ba
		Color rc,gc,bc
		Rect x,0,1,40,1
	Next
	If layer_gradient(layer)=2 Then Color 0,255,0:Rect 0,0,67,40,0
	FlipCanvas(opt_gradient(2))
	;Gradient 3
	SetBuffer CanvasBuffer(opt_gradient(3))
	ClsColor r1,g1,b1
	Cls
	rc=r1:gc=g1:bc=b1
	ra=r1-r2:ga=g1-g2:ba=b1-b2
	If ra<>0 Then ra=ra/40.
	If ga<>0 Then ga=ga/40.
	If ba<>0 Then ba=ba/40.
	For y=0 To 40
		rc=rc-ra:gc=gc-ga:bc=bc-ba
		Color rc,gc,bc
		Rect 0,y,67,1,1
	Next
	If layer_gradient(layer)=3 Then Color 0,255,0:Rect 0,0,67,40,0
	FlipCanvas(opt_gradient(3))
	;Gradient 4
	SetBuffer CanvasBuffer(opt_gradient(4))
	ClsColor r1,g1,b1
	Cls
	rc=r1:gc=g1:bc=b1
	ra=r1-r2:ga=g1-g2:ba=b1-b2
	If ra<>0 Then ra=ra/34.
	If ga<>0 Then ga=ga/34.
	If ba<>0 Then ba=ba/34.
	For x=0 To 34
		rc=rc-ra:gc=gc-ga:bc=bc-ba
		Color rc,gc,bc
		Rect x,0,1,40,1
	Next
	For x=34 To 67
		rc=rc+ra:gc=gc+ga:bc=bc+ba
		Color rc,gc,bc
		Rect x,0,1,40,1
	Next
	If layer_gradient(layer)=4 Then Color 0,255,0:Rect 0,0,67,40,0
	FlipCanvas(opt_gradient(4))
	;Gradient 5
	SetBuffer CanvasBuffer(opt_gradient(5))
	ClsColor r1,g1,b1
	Cls
	rc=r1:gc=g1:bc=b1
	ra=r1-r2:ga=g1-g2:ba=b1-b2
	If ra<>0 Then ra=ra/20.
	If ga<>0 Then ga=ga/20.
	If ba<>0 Then ba=ba/20.
	For y=0 To 20
		rc=rc-ra:gc=gc-ga:bc=bc-ba
		Color rc,gc,bc
		Rect 0,y,67,1,1
	Next
	For y=20 To 40
		rc=rc+ra:gc=gc+ga:bc=bc+ba
		Color rc,gc,bc
		Rect 0,y,67,1,1
	Next
	If layer_gradient(layer)=5 Then Color 0,255,0:Rect 0,0,67,40,0
	FlipCanvas(opt_gradient(5))
End Function

;Layer load
Function layer_load()
	;Gewhlter Layer
	For i=0 To 9
		If ButtonState(win_layer(i))=1 Then 
			layer=i
			Exit
		EndIf
	Next
	;Options Layer
	SetGadgetText opt_layer, "Layer "+layer
	SetGadgetText opt_layer_name,layer_name$(layer)
	;Options Font
	If layer_font(layer)=0 Then
		SetGadgetText opt_font_prev,"No Font loaded!"
		SetGadgetFont opt_font_prev,arial
	Else
		SetGadgetText opt_font_prev,"AaBbYyZz"
		SetGadgetFont opt_font_prev,layer_font(layer)
	EndIf
	;Options Color
	SetPanelColor opt_color1,layer_rgb1(layer,0),layer_rgb1(layer,1),layer_rgb1(layer,2)
	SetPanelColor opt_color2,layer_rgb2(layer,0),layer_rgb2(layer,1),layer_rgb2(layer,2)
	;Options Gradient
	gradients()
	;Options Border
	SetGadgetText opt_border_thick, layer_border(layer)
	;Options Offset
	SetGadgetText opt_x, layer_x(layer)
	SetGadgetText opt_y, layer_y(layer)
End Function

;Layer Save
Function layer_save()
	;Options Layer
	layer_name$(layer)=TextFieldText(opt_layer_name)
	If layer_font(layer)=0 Then
		SetGadgetText win_layer(layer),"Layer "+(layer)+" - "+layer_name$(layer)
	Else
		SetGadgetText win_layer(layer),Chr(149)+" Layer "+(layer)+" - "+layer_name$(layer)+"
	EndIf
	;Options Border
	layer_border(layer)=Int(TextFieldText(opt_border_thick))
	;Options Offset
	layer_x(layer)=Int(TextFieldText(opt_x))
	layer_y(layer)=Int(TextFieldText(opt_y))
End Function


;Generate
Function generate(genstr$,output_bmp$="",output_w$="",sharp=1,prevmode=0,output_bmpf$="")
	;Zeichen
	sframe=0
	genstrlen=Len(genstr$)
	If genstr$="[ASCII]" Then genstrlen=256

	;Gre ermitteln
	Local ox,oy					;Start Offset
	Local maxx,maxy				;Maximale Gre X/Y
	
	
	For i=0 To 9
		;Schriften durchgehen
		If layer_font(i)<>0 Then
			SetFont layer_font(i)
			
			;Start Offset ermitteln
			;X
			oxc=layer_border(i)
			If layer_x(i)<0 Then  oxc=oxc+Abs(layer_x(i))
			If oxc>ox Then ox=oxc
			;Y
			oyc=layer_border(i)
			If layer_y(i)<0 Then  oyc=oyc+Abs(layer_y(i))
			If oyc>oy Then oy=oyc
			
			;End Offset
			x=0:y=0
			y=FontHeight()+layer_border(i)
			If layer_y(i)>0 Then  y=y+Abs(layer_y(i))
			For s=1 To genstrlen
			
				If genstr$="[ASCII]" Then
					sign=s-1
				Else
					sign=Asc(Mid(genstr$,s,1))
				EndIf
				
				x=StringWidth(Chr$(sign))+layer_border(i)
				If layer_x(i)>0 Then  x=x+Abs(layer_x(i))
				If x+oxc>maxx Then maxx=x+oxc
			Next	
			If y+oyc>maxy Then maxy=y+oyc
		EndIf
	Next
	
	
	;Null?
	If maxx=0 Or maxy=0 Then
		Notify("Error: No font loaded",1)
		Return 0
	EndIf
	
	;Werte
	bitmapfont_frames=genstrlen
	bitmapfont_framesx=maxx
	bitmapfont_framesy=maxy
	Dim bitmapfont_c(bitmapfont_frames)
	Dim bitmapfont_w(bitmapfont_frames)
	
	;Mask
	If mac(0)=0 And mac(1)=0 And mac(2)=0 Then
		mac2(0)=255:mac2(1)=0:mac2(2)=255
	Else
		mac2(0)=0:mac2(1)=0:mac2(2)=0
	EndIf
	;Erstellen
	If bitmapfont<>0 Then FreeImage bitmapfont
	bitmapfont=CreateImage(maxx,maxy,genstrlen+1)
	If mask<>0 Then FreeImage mask
	mask=CreateImage(maxx,maxy,1):MaskImage mask,mac2(0),mac2(1),mac2(2)
	If gradient<>0 Then FreeImage gradient
	gradient=CreateImage(maxx,maxy,1):MaskImage gradient,mac(0),mac(1),mac(2)
	
	;Rendern
	For genstrpos=1 To genstrlen
	
		;Progress
		ShowGadget win_progrbar
		percent#=Float(genstrpos)/Float(genstrlen)
		UpdateProgBar win_progrbar,percent#
	
		If genstr$="[ASCII]" Then
			sign=genstrpos-1
		Else
			sign=Asc(Mid(genstr$,genstrpos,1))
		EndIf
		
		SetBuffer ImageBuffer(bitmapfont,sframe)
		ClsColor mac(0),mac(1),mac(2)
		Cls
	
		;Layer durchgehen (von unten nach oben)
		For cl=9 To 0 Step -1
				
			;Layer verwendet?
			If layer_font(cl)<>0 Then
						
				;No Gradient
				If layer_gradient(cl)=0 Then
					SetBuffer ImageBuffer(gradient)
					ClsColor mac(0),mac(1),mac(2)
					Cls
					Color layer_rgb1(cl,0), layer_rgb1(cl,1), layer_rgb1(cl,2)
					SetFont layer_font(cl)
					For bx=-layer_border(cl) To layer_border(cl)
						For by=-layer_border(cl) To layer_border(cl)
							Text ox+bx+layer_x(cl),oy+by+layer_y(cl), Chr(sign)
						Next
					Next
					If sharp Then maskfix(gradient, -1, layer_rgb1(cl,0), layer_rgb1(cl,1), layer_rgb1(cl,2),mac(0),mac(1),mac(2))
					SetBuffer ImageBuffer(bitmapfont,sframe)
					DrawImage gradient,0,0
					
				;Gradient
				Else
				
					;Mask
					SetBuffer ImageBuffer(mask)
					ClsColor mac(0),mac(1),mac(2)
					Cls
					Color mac2(0),mac2(1),mac2(2)
					SetFont layer_font(cl)
					For bx=-layer_border(cl) To layer_border(cl)
						For by=-layer_border(cl) To layer_border(cl)
							Text ox+bx+layer_x(cl),oy+by+layer_y(cl), Chr(sign)
						Next
					Next
					If sharp Then maskfix(mask,-1,mac2(0),mac2(1),mac2(2),mac(0),mac(1),mac(2))
					
					;Gradient
					SetBuffer ImageBuffer(gradient)
					Local r1,g1,b1
					Local r2,g2,b2
					Local rc#,gc#,bc#
					Local ra#,ga#,ba#
					r1=layer_rgb1(cl,0)
					g1=layer_rgb1(cl,1)
					b1=layer_rgb1(cl,2)
					r2=layer_rgb2(cl,0)
					g2=layer_rgb2(cl,1)
					b2=layer_rgb2(cl,2)
					
					Select  layer_gradient(cl)

						;Gradient 1
						Case 1							
							ClsColor r2,g2,b2
							Cls
							rc=r2:gc=g2:bc=b2
							ra=r2-r1:ga=g2-g1:ba=b2-b1
							If ra<>0 Then ra=ra/(maxy/2.)
							If ga<>0 Then ga=ga/(maxy/2.)
							If ba<>0 Then ba=ba/(maxy/2.)
							For y=(maxy/2) To 0 Step -1
								rc=rc-ra:gc=gc-ga:bc=bc-ba
								Color Int(rc),Int(gc),Int(bc)
								Oval (maxy/2)-y,(maxy/2)-y,(y*2),(y*2),1
							Next				
							
						;Gradient 2
						Case 2
							ClsColor r1,g1,b1
							Cls
							rc=r1:gc=g1:bc=b1
							ra=r1-r2:ga=g1-g2:ba=b1-b2
							If ra<>0 Then ra=ra/maxx
							If ga<>0 Then ga=ga/maxx
							If ba<>0 Then ba=ba/maxx
							For x=0 To maxx
								rc=rc-ra:gc=gc-ga:bc=bc-ba
								Color rc,gc,bc
								Rect x,0,1,maxy,1
							Next
		
						;Gradient 3
						Case 3
							ClsColor r1,g1,b1
							Cls
							rc=r1:gc=g1:bc=b1
							ra=r1-r2:ga=g1-g2:ba=b1-b2
							If ra<>0 Then ra=ra/maxy
							If ga<>0 Then ga=ga/maxy
							If ba<>0 Then ba=ba/maxy
							For y=0 To maxy
								rc=rc-ra:gc=gc-ga:bc=bc-ba
								Color rc,gc,bc
								Rect 0,y,maxx,1,1
							Next
							
						;Gradient 4
						Case 4
							ClsColor r1,g1,b1
							Cls
							rc=r1:gc=g1:bc=b1
							ra=r1-r2:ga=g1-g2:ba=b1-b2
							If ra<>0 Then ra=ra/(maxx/2.)
							If ga<>0 Then ga=ga/(maxx/2.)
							If ba<>0 Then ba=ba/(maxx/2.)
							For x=0 To (maxx/2)
								rc=rc-ra:gc=gc-ga:bc=bc-ba
								Color rc,gc,bc
								Rect x,0,1,maxy,1
							Next
							For x=(maxx/2) To maxx
								rc=rc+ra:gc=gc+ga:bc=bc+ba
								Color rc,gc,bc
								Rect x,0,1,maxy,1
							Next
		
						;Gradient 5
						Case 5
							ClsColor r1,g1,b1
							Cls
							rc=r1:gc=g1:bc=b1
							ra=r1-r2:ga=g1-g2:ba=b1-b2
							If ra<>0 Then ra=ra/(maxy/2.)
							If ga<>0 Then ga=ga/(maxy/2.)
							If ba<>0 Then ba=ba/(maxy/2.)
							For y=0 To (maxy/2)
								rc=rc-ra:gc=gc-ga:bc=bc-ba
								Color rc,gc,bc
								Rect 0,y,maxx,1,1
							Next
							For y=(maxy/2) To maxy
								rc=rc+ra:gc=gc+ga:bc=bc+ba
								Color rc,gc,bc
								Rect 0,y,maxx,1,1
							Next
							
						;Gradient 6 (Texture Fill)
						Case 6
							If layer_texture(cl)<>0 Then
								TileBlock layer_texture(cl)
							EndIf
					
					End Select
					
					;Add Mask to Gradient
					DrawImage mask,0,0
					
					;Add all to Font
					SetBuffer ImageBuffer(bitmapfont,sframe)
					DrawImage gradient,0,0
					
					
				EndIf
					
			EndIf
		Next
		
		;Zeichen in Array speichern
		bitmapfont_c(sframe)=sign
		
		;Width ermitteln
		SetBuffer ImageBuffer(bitmapfont,sframe)
		w=0
		LockBuffer()
		For wx=0 To maxx-1
			For wy=0 To maxy-1
				wrgb=ReadPixelFast(wx,wy)
				wr=(wrgb And $FF0000)/$10000
				wg=(wrgb And $FF00)/$100
				wb=wrgb And $FF
				If Abs(wr-mac(0))<>0 Or Abs(wg-mac(1))<>0 Or Abs(wb-mac(2))<>0 Then
					If w<wx+1 Then w=wx+1
				EndIf
			Next
		Next
		If w=0 Then w=maxx/1.5
		bitmapfont_w(sframe)=w
		UnlockBuffer()
		
		
		sframe=sframe+1
	Next
	;Ok
	HideGadget win_progrbar
	y=0
	
	;Draw On Preview Area
	SetBuffer CanvasBuffer(win_preview)
	;BG
	Color 150,150,150
	Rect 0,0,400,285,1
	Color 200,200,200
	i=0
	For y=0 To 285 Step 8
		For x=0 To 400 Step 8
			i=1-i
			If i Then Rect x,y,8,8,1
		Next
	Next
	MaskImage bitmapfont,mac(0),mac(1),mac(2)
	;Font
	If prevmode=0 Then
		i=0
		x=0
		y=0
		For i=0 To genstrlen-1
			DrawImage bitmapfont,x,y,i
			x=x+maxx
			If x>=400 Then
				x=0
				y=y+maxy+2
			EndIf
		Next
	Else
		i=0
		x=0
		y=0
		For i=0 To genstrlen-1
			DrawImage bitmapfont,x,y,i
			x=x+bitmapfont_w(i)
			If x>=400 Then
				x=0
				y=y+maxy+2
			EndIf
		Next
	EndIf
	FlipCanvas win_preview
	
	;Output Image
	If Len(output_bmp$)>0 Then
		save=CreateImage(maxx*genstrlen,maxy,1)
		SetBuffer ImageBuffer(save)
		ClsColor mac(0),mac(1),mac(2)
		Cls
		For x=0 To genstrlen
			DrawBlock bitmapfont,x*maxx,0,x
		Next
		SaveImage (save,output_bmp$)
		FreeImage save
	EndIf
	
	;Output Widths
	If Len(output_w$)>0 Then
		stream=WriteFile(output_w$)
		If stream Then
			For x=0 To genstrlen
				WriteLine stream,bitmapfont_w(x)
			Next
			CloseFile(stream)
		Else
			Notify("Error: Unable to save char widths!",1)
			Return 0
		EndIf
	EndIf
	
	;Output BMPF
	If Len(output_bmpf$)>0 Then
		stream=WriteFile(output_bmpf$)
		If stream Then
			WriteLine stream,"Unreal Software Bitmap Font Wizard bmpf File"
			WriteShort stream,bitmapfont_frames
			WriteShort stream,bitmapfont_framesx
			WriteShort stream,bitmapfont_framesy
			For x=0 To genstrlen
				WriteByte stream,bitmapfont_c(x)
				WriteShort stream,bitmapfont_w(x)
			Next
			CloseFile(stream)
		Else
			Notify("Error: Unable to save bmpf file!",1)
			Return 0
		EndIf		
	EndIf
	
	;OK
	Return 1
End Function


;Maskfix
Function maskfix(cimg,cframe,cr1,cg1,cb1,cr2,cg2,cb2)
	cxs=ImageWidth(cimg)
	cys=ImageHeight(cimg)
	If cframe>-1 Then
		SetBuffer ImageBuffer(cimg,cframe)
	Else
		SetBuffer ImageBuffer(cimg)
	EndIf
	LockBuffer()
	For cx=0 To cxs-1
		For cy=0 To cys-1
			crgb=ReadPixelFast(cx,cy)
		cr=(crgb And $FF0000)/$10000
		cg=(crgb And $FF00)/$100
		cb=crgb And $FF
			If Abs(cr-cr1)>0 Or Abs(cg-cg1)>0 Or Abs(cb-cb1)>0 Then
			crgb=ca*$1000000 + cr2*$10000 + cg2*$100 + cb2
				WritePixelFast cx,cy,crgb
			EndIf
		Next
	Next
	UnlockBuffer()
End Function


;Charset
Function charset()
	index=SelectedGadgetItem(win_exp_ch_sel)
	SetTextAreaText(win_exp_ch,"")
	Select GadgetItemText(win_exp_ch_sel,index)
		Case "ASCII (256 chars)"
			SetTextAreaText(win_exp_ch,"[ASCII]")
		Case "ASCII 33-126  (94 chars)"
			SetTextAreaText(win_exp_ch,"!"+Chr(34)+"#$%&'()*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\]^_`abcdefghijklmnopqrstuvwxyz{|}~")
		Case "Numbers (10)"
			SetTextAreaText(win_exp_ch,"0123456789")
		Case "Alphabet a (26)"
			SetTextAreaText(win_exp_ch,"ABCDEFGHIJKLMNOPQRSTUVWXYZ")
		Case "Alphabet b (52)"
			SetTextAreaText(win_exp_ch,"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz")
		Case "Basic (62)"
			SetTextAreaText(win_exp_ch,"01234567890ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz")
	End Select
End Function


;Infos
Function infos(show=1)
	;Show?
	If show Then ShowGadget win_inf:ActivateWindow(win_inf)
	
	;Infos
	SetGadgetText win_inf_frames, "Frames/Chars: "+bitmapfont_frames
	SetGadgetText win_inf_framesx, "Frame Width (X): "+bitmapfont_framesx
	SetGadgetText win_inf_framesy, "Frame Height (Y): "+bitmapfont_framesy
	
	;Widths
	SetTextAreaText(win_inf_charw,"")
	i=0
	AddTextAreaText(win_inf_charw,(i)+" - "+Chr(bitmapfont_c(i))+" - Width: "+bitmapfont_w(i)+" px")
	For i=1 To bitmapfont_frames-1
		If bitmapfont_c(i)<15 Then
			AddTextAreaText(win_inf_charw,Chr(13)+(i)+" -   - Width: "+bitmapfont_w(i)+" px")
		Else
			AddTextAreaText(win_inf_charw,Chr(13)+(i)+" - "+Chr(bitmapfont_c(i))+" - Width: "+bitmapfont_w(i)+" px")
		EndIf
	Next

	;Code
	code$=""
	If TextAreaText(win_exp_ch)="[ASCII]" And bitmapfont_frames=256 Then
		code$=code$+";---------------------------------------------Bitmap Font Wizard Code - *START*"+Chr(13)
		code$=code$+"Global bmpf=LoadAnimImage("+Chr(34)+TextFieldText(win_exp_bmp)+Chr(34)+","+bitmapfont_framesx+","+bitmapfont_framesy+",0,"+bitmapfont_frames+")"+Chr(13)
		code$=code$+"MaskImage bmpf,"+mac(0)+","+mac(1)+","+mac(2)+Chr(13)
		code$=code$+"Global bmpf_frames="+(bitmapfont_frames-1)+Chr(13)
		code$=code$+"Dim bmpf_w(bmpf_frames)"+Chr(13)
		For i=0 To (bitmapfont_frames-1)
			If i Mod 10 Then
				code$=code$+"bmpf_w("+i+")="+bitmapfont_w(i)+":"
			Else
				code$=code$+"bmpf_w("+i+")="+bitmapfont_w(i)+Chr(13)
			EndIf
		Next
		code$=code$+Chr(13)+Chr(13)
		code$=code$+"Function bmpf_txt(x,y,txt$)"+Chr(13)
		code$=code$+"	charcount=len(txt$)"+Chr(13)
		code$=code$+"	For i=1 to charcount"+Chr(13)
		code$=code$+"		char=Asc(Mid(txt$,i,1))"+Chr(13)
		code$=code$+"		DrawImage bmpf,x,y,char"+Chr(13)
		code$=code$+"		x=x+bmpf_w(char)"+Chr(13)
		code$=code$+"	Next"+Chr(13)
		code$=code$+"End Function"+Chr(13)
		code$=code$+";---------------------------------------------Bitmap Font Wizard Code - *END*"+Chr(13)
	Else
		code$=code$+";---------------------------------------------Bitmap Font Wizard Code - *START*"+Chr(13)
		code$=code$+"Global bmpf=LoadAnimImage("+Chr(34)+TextFieldText(win_exp_bmp)+Chr(34)+","+bitmapfont_framesx+","+bitmapfont_framesy+",0,"+bitmapfont_frames+")"+Chr(13)
		code$=code$+"MaskImage bmpf,"+mac(0)+","+mac(1)+","+mac(2)+Chr(13)
		code$=code$+"Global bmpf_frames="+(bitmapfont_frames-1)+Chr(13)
		code$=code$+"Dim bmpf_c(bmpf_frames)"+Chr(13)
		For i=0 To (bitmapfont_frames-1)
			If i Mod 10 Then
				code$=code$+"bmpf_c("+i+")="+bitmapfont_c(i)+":"
			Else
				code$=code$+"bmpf_c("+i+")="+bitmapfont_c(i)+Chr(13)
			EndIf
		Next
		code$=code$+Chr(13)
		code$=code$+"Dim bmpf_w(bmpf_frames)"+Chr(13)
		For i=0 To (bitmapfont_frames-1)
			If i Mod 10 Then
				code$=code$+"bmpf_w("+i+")="+bitmapfont_w(i)+":"
			Else
				code$=code$+"bmpf_w("+i+")="+bitmapfont_w(i)+Chr(13)
			EndIf
		Next
		code$=code$+Chr(13)+Chr(13)
		code$=code$+"Function bmpf_txt(x,y,txt$)"+Chr(13)
		code$=code$+"	charcount=len(txt$)"+Chr(13)
		code$=code$+"	For i=1 to charcount"+Chr(13)
		code$=code$+"		char=Asc(Mid(txt$,i,1))"+Chr(13)
		code$=code$+"		If char=32"+Chr(13)
		code$=code$+"			x=x+"+(Int(bitmapfont_framesx/1.5))+Chr(13)
		code$=code$+"		Else"+Chr(13)
		code$=code$+"			For j=0 to bmpf_frames"+Chr(13)
		code$=code$+"				If bmpf_c(j)=char Then"+Chr(13)
		code$=code$+"					DrawImage bmpf,x,y,j"+Chr(13)
		code$=code$+"					x=x+bmpf_w(j)"+Chr(13)
		code$=code$+"					Exit"+Chr(13)
		code$=code$+"				Endif"+Chr(13)
		code$=code$+"			Next"+Chr(13)
		code$=code$+"		Endif"+Chr(13)
		code$=code$+"	Next"+Chr(13)
		code$=code$+"End Function"+Chr(13)
		code$=code$+";---------------------------------------------Bitmap Font Wizard Code - *END*"+Chr(13)
	EndIf
	SetTextAreaText win_inf_code, code$
End Function